| QxOrm 1.3.1 C++ Object Relational Mapping library

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends
qx::QxDataMemberX< T > Class Template Reference
QxDataMember : QxOrm library data member (or property) used by introspection engine

qx::QxDataMemberX<T> : concrete list of properties registered into QxOrm context for the class T More...

`#include <QxDataMemberX.h>`

Inheritance diagram for qx::QxDataMemberX< T >:

List of all members.

## Public Types
typedef qx::trait::get_primary_key< T > ::type | type_primary_key
typedef qx::trait::get_base_class< T > ::type | type_base_class
## Public Member Functions
virtual IxDataMember * | getId () const
virtual long | count_WithDaoStrategy () const
virtual bool | exist_WithDaoStrategy (const QString &sKey) const
virtual IxDataMember * | get_WithDaoStrategy (long lIndex) const
virtual IxDataMember * | get_WithDaoStrategy (const QString &sKey) const
virtual IxDataMember * | getId_WithDaoStrategy () const
IxDataMember * | id (type_primary_key T::*pDataMemberId, const QString &sKey)
IxDataMember * | id (type_primary_key T::*pDataMemberId, const QString &sKey, long lVersion)
IxDataMember * | id (const QString &sKey, long lVersion)
IxDataMember * | add (const QString &sKey, long lVersion)
template<typename V , typename U >
IxDataMember * | add (V U::*pData, const QString &sKey)
template<typename V , typename U >
IxDataMember * | add (V U::*pData, const QString &sKey, long lVersion)
template<typename V , typename U >
IxDataMember * | add (V U::*pData, const QString &sKey, long lVersion, bool bSerialize)
template<typename V , typename U >
IxDataMember * | add (V U::*pData, const QString &sKey, long lVersion, bool bSerialize, bool bDao)
template<typename V , typename U >
IxSqlRelation * | relationOneToOne (V U::*pData, const QString &sKey)
template<typename V , typename U >
IxSqlRelation * | relationOneToOne (V U::*pData, const QString &sKey, long lVersion)
template<typename V , typename U >
IxSqlRelation * | relationManyToOne (V U::*pData, const QString &sKey)
template<typename V , typename U >
IxSqlRelation * | relationManyToOne (V U::*pData, const QString &sKey, long lVersion)
template<typename V , typename U >
IxSqlRelation * | relationOneToMany (V U::*pData, const QString &sKey, const QString &sForeignKey)
template<typename V , typename U >
IxSqlRelation * | relationOneToMany (V U::*pData, const QString &sKey, const QString &sForeignKey, long lVersion)
template<typename V , typename U >
IxSqlRelation * | relationManyToMany (V U::*pData, const QString &sKey, const QString &sExtraTable, const QString &sForeignKeyOwner, const QString &sForeignKeyDataType)
template<typename V , typename U >
IxSqlRelation * | relationManyToMany (V U::*pData, const QString &sKey, const QString &sExtraTable, const QString &sForeignKeyOwner, const QString &sForeignKeyDataType, long lVersion)
template<class Archive >
void | toArchive (const T *pOwner, Archive &ar, const unsigned int file_version) const
template<class Archive >
void | fromArchive (T *pOwner, Archive &ar, const unsigned int file_version)
## Protected Member Functions
| QxDataMemberX ()
virtual | ~QxDataMemberX ()
## Protected Attributes
IxDataMember * | m_pDataMemberId
| Data member id with primary key type.
## Private Member Functions
IxDataMember * | initId (IxDataMember *pId, long lVersion)
IxDataMember * | initData (IxDataMember *pData, long lVersion)
IxDataMemberX * | getBaseClass_Helper () const
long | count_WithDaoStrategy_Helper () const
bool | exist_WithDaoStrategy_Helper (const QString &sKey) const
IxDataMember * | get_WithDaoStrategy_Helper (long lIndex) const
IxDataMember * | get_WithDaoStrategy_Helper (const QString &sKey) const
IxDataMember * | getId_WithDaoStrategy_Helper () const
## Friends
class | QxSingleton< QxDataMemberX< T > >

## Detailed Description

### template<class T>
class qx::QxDataMemberX< T >

qx::QxDataMemberX<T> : concrete list of properties registered into QxOrm context for the class T

Definition at line 71 of file QxDataMemberX.h.

## Member Typedef Documentation

template<class T>

typedef qx::trait::get_base_class<T>::type qx::QxDataMemberX< T >::type_base_class

Definition at line 79 of file QxDataMemberX.h.

template<class T>

typedef qx::trait::get_primary_key<T>::type qx::QxDataMemberX< T >::type_primary_key

Definition at line 78 of file QxDataMemberX.h.

## Constructor & Destructor Documentation

template<class T>

qx::QxDataMemberX< T >::QxDataMemberX | ( |  | ) | `[inline, protected]`

Definition at line 87 of file QxDataMemberX.h.

template<class T>

virtual qx::QxDataMemberX< T >::~QxDataMemberX | ( |  | ) | `[inline, protected, virtual]`

Definition at line 88 of file QxDataMemberX.h.

## Member Function Documentation

template<class T>

IxDataMember* qx::QxDataMemberX< T >::add | ( | const QString & | sKey,
|  | long | lVersion
| ) |  |

template<class T>
template<typename V , typename U >

IxDataMember* qx::QxDataMemberX< T >::add | ( | V U::* | pData,
|  | const QString & | sKey
| ) |  |

template<class T>
template<typename V , typename U >

IxDataMember* qx::QxDataMemberX< T >::add | ( | V U::* | pData,
|  | const QString & | sKey,
|  | long | lVersion
| ) |  |

template<class T>
template<typename V , typename U >

IxDataMember* qx::QxDataMemberX< T >::add | ( | V U::* | pData,
|  | const QString & | sKey,
|  | long | lVersion,
|  | bool | bSerialize
| ) |  |

template<class T>
template<typename V , typename U >

IxDataMember* qx::QxDataMemberX< T >::add | ( | V U::* | pData,
|  | const QString & | sKey,
|  | long | lVersion,
|  | bool | bSerialize,
|  | bool | bDao
| ) |  |

template<class T>

virtual long qx::QxDataMemberX< T >::count_WithDaoStrategy | ( |  | ) | const`[inline, virtual]`

Implements qx::IxDataMemberX.

Definition at line 94 of file QxDataMemberX.h.

template<class T>

long qx::QxDataMemberX< T >::count_WithDaoStrategy_Helper | ( |  | ) | const`[inline, private]`

Definition at line 129 of file QxDataMemberX.h.

template<class T>

virtual bool qx::QxDataMemberX< T >::exist_WithDaoStrategy | ( | const QString & | sKey | ) | const`[inline, virtual]`

Implements qx::IxDataMemberX.

Definition at line 95 of file QxDataMemberX.h.

template<class T>

bool qx::QxDataMemberX< T >::exist_WithDaoStrategy_Helper | ( | const QString & | sKey | ) | const`[inline, private]`

Definition at line 140 of file QxDataMemberX.h.

template<class T>
template<class Archive >

void qx::QxDataMemberX< T >::fromArchive | ( | T * | pOwner,
|  | Archive & | ar,
|  | const unsigned int | file_version
| ) |  | `[inline]`

template<class T>

virtual IxDataMember* qx::QxDataMemberX< T >::get_WithDaoStrategy | ( | long | lIndex | ) | const`[inline, virtual]`

Implements qx::IxDataMemberX.

Definition at line 96 of file QxDataMemberX.h.

template<class T>

virtual IxDataMember* qx::QxDataMemberX< T >::get_WithDaoStrategy | ( | const QString & | sKey | ) | const`[inline, virtual]`

Implements qx::IxDataMemberX.

Definition at line 97 of file QxDataMemberX.h.

template<class T>

IxDataMember* qx::QxDataMemberX< T >::get_WithDaoStrategy_Helper | ( | long | lIndex | ) | const`[inline, private]`

Definition at line 151 of file QxDataMemberX.h.

template<class T>

IxDataMember* qx::QxDataMemberX< T >::get_WithDaoStrategy_Helper | ( | const QString & | sKey | ) | const`[inline, private]`

Definition at line 162 of file QxDataMemberX.h.

template<class T>

IxDataMemberX* qx::QxDataMemberX< T >::getBaseClass_Helper | ( |  | ) | const`[inline, private]`

Definition at line 127 of file QxDataMemberX.h.

template<class T>

virtual IxDataMember* qx::QxDataMemberX< T >::getId | ( |  | ) | const`[inline, virtual]`

Implements qx::IxDataMemberX.

Definition at line 92 of file QxDataMemberX.h.

template<class T>

virtual IxDataMember* qx::QxDataMemberX< T >::getId_WithDaoStrategy | ( |  | ) | const`[inline, virtual]`

Implements qx::IxDataMemberX.

Definition at line 98 of file QxDataMemberX.h.

template<class T>

IxDataMember* qx::QxDataMemberX< T >::getId_WithDaoStrategy_Helper | ( |  | ) | const`[inline, private]`

Definition at line 173 of file QxDataMemberX.h.

template<class T>

IxDataMember* qx::QxDataMemberX< T >::id | ( | type_primary_key T::* | pDataMemberId,
|  | const QString & | sKey
| ) |  |

template<class T>

IxDataMember* qx::QxDataMemberX< T >::id | ( | type_primary_key T::* | pDataMemberId,
|  | const QString & | sKey,
|  | long | lVersion
| ) |  |

template<class T>

IxDataMember* qx::QxDataMemberX< T >::id | ( | const QString & | sKey,
|  | long | lVersion
| ) |  |

template<class T>

IxDataMember* qx::QxDataMemberX< T >::initData | ( | IxDataMember * | pData,
|  | long | lVersion
| ) |  | `[private]`

template<class T>

IxDataMember* qx::QxDataMemberX< T >::initId | ( | IxDataMember * | pId,
|  | long | lVersion
| ) |  | `[private]`

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationManyToMany | ( | V U::* | pData,
|  | const QString & | sKey,
|  | const QString & | sExtraTable,
|  | const QString & | sForeignKeyOwner,
|  | const QString & | sForeignKeyDataType
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationManyToMany | ( | V U::* | pData,
|  | const QString & | sKey,
|  | const QString & | sExtraTable,
|  | const QString & | sForeignKeyOwner,
|  | const QString & | sForeignKeyDataType,
|  | long | lVersion
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationManyToOne | ( | V U::* | pData,
|  | const QString & | sKey
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationManyToOne | ( | V U::* | pData,
|  | const QString & | sKey,
|  | long | lVersion
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationOneToMany | ( | V U::* | pData,
|  | const QString & | sKey,
|  | const QString & | sForeignKey
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationOneToMany | ( | V U::* | pData,
|  | const QString & | sKey,
|  | const QString & | sForeignKey,
|  | long | lVersion
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationOneToOne | ( | V U::* | pData,
|  | const QString & | sKey
| ) |  |

template<class T>
template<typename V , typename U >

IxSqlRelation* qx::QxDataMemberX< T >::relationOneToOne | ( | V U::* | pData,
|  | const QString & | sKey,
|  | long | lVersion
| ) |  |

template<class T>
template<class Archive >

void qx::QxDataMemberX< T >::toArchive | ( | const T * | pOwner,
|  | Archive & | ar,
|  | const unsigned int | file_version
| ) |  | const`[inline]`

## Friends And Related Function Documentation

template<class T>

friend class QxSingleton< QxDataMemberX< T > >`[friend]`

Definition at line 74 of file QxDataMemberX.h.

## Member Data Documentation

template<class T>

IxDataMember* qx::QxDataMemberX< T >::m_pDataMemberId`[protected]`

Data member id with primary key type.

Definition at line 83 of file QxDataMemberX.h.

The documentation for this class was generated from the following file:

- D:/Dvlp/_Perso/QxOrm/include/QxDataMember/QxDataMemberX.h